# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ......core.datetime_utils import serialize_datetime
from .....commons.types.facility_type_code import FacilityTypeCode
from .....commons.types.network_type import NetworkType
from .....commons.types.procedure_modifier import ProcedureModifier
from .....commons.types.state import State
from .....organization_providers.resources.v_2.types.license_type import LicenseType
from .....organization_providers.resources.v_2.types.organization_provider_id import OrganizationProviderId
from .....payers.resources.v_3.types.payer_uuid import PayerUuid

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class OptionalDimensions(pydantic.BaseModel):
    """
    A dimensions object where all properties are optional.
    """

    payer_uuid: typing.Optional[PayerUuid] = None
    organization_billing_provider_id: typing.Optional[OrganizationProviderId] = None
    states: typing.List[State]
    zip_codes: typing.List[str]
    license_types: typing.List[LicenseType]
    facility_type_codes: typing.List[FacilityTypeCode]
    network_types: typing.List[NetworkType]
    cpt_code: typing.Optional[str] = None
    modifiers: typing.List[ProcedureModifier]

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
